#include "stdafx.h"
#include "resource.h"
#include "unzip.h"


HINSTANCE			hInst;
LRESULT CALLBACK	MainDlgProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	PassDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

LPTSTR	g_szCmdLine = NULL;
CHAR	g_szPass[256];

HICON	g_hIconBig;
HICON	g_hIconSmall;
BOOL	g_bHalt;				// ?

int		g_nCodePage=936;		// 932=japan

struct SCodePage
{
	LPCTSTR szDesc;
	int		nCodepage;
};

SCodePage g_supportedCodePages[]=
{
	{ _T("Ϻ"), 932 },
	{ _T("߱(ü)"), 936 },
	{ _T("߱(ü)"), 950 },
	{ _T("ѱ"), 949 },
};



//CP_ACP

#define APP _T("ZIPJ")


LPCTSTR TXT_ABOUT = 
	_T(" α׷ Ϻε .ZIP   ϴ α׷ Դϴ.\r\n\r\n")
	_T("Ȩ : www.kipple.pe.kr");

#ifndef _MAX_PATH
#   define _MAX_PATH   260 /* max. length of full pathname */
#endif

BOOL IsFolder(LPCTSTR szPathName)
{
	UINT32 dwRet;
	dwRet = GetFileAttributes(szPathName);
	if(dwRet==0xffffffff) return FALSE;
	if(dwRet & FILE_ATTRIBUTE_DIRECTORY) return TRUE;
	return FALSE;
}


#define PATHSEP _T("\\")

BOOL DigPath(LPCTSTR szPathName)
{
	TCHAR*	dup = _tcsdup(szPathName);
	TCHAR	seps[]   = _T("/\\");
	TCHAR*	token;
	TCHAR	path[MAX_PATH] = {0};
	TCHAR*	last;

	// θ ̱.
	last = dup + lstrlen(dup);
	while(last!=dup)
	{
		if(*last=='/' || *last=='\\') 
		{
			*last = (char)NULL;
			break;
		}
		last --;
	}

	
	token = _tcstok( dup, seps );
	while( token != NULL )
	{
		if(lstrlen(path)==0)
		{
			if(szPathName[0]=='/')			// is absolute path ?
				lstrcpy(path,_T("/"));
			lstrcat(path, token);
		}
		else
		{
			lstrcat(path, PATHSEP);
			lstrcat(path, token);
		}

		if(IsFolder(path)==FALSE)
			_tmkdir(path);
		token = _tcstok( NULL, seps );
	}

	free(dup);
	if(IsFolder(szPathName)) return TRUE;
	return FALSE;
}



int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;

	g_hIconBig = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ZIPJ));
	g_hIconSmall = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_SMALL));

	//g_szCmdLine = lpCmdLine;
	g_szCmdLine = new TCHAR[_tcslen(lpCmdLine)+1];
	TCHAR* p;
	TCHAR* q;
	p = lpCmdLine;
	q = g_szCmdLine;
	while(*p)
	{
		if(*p!='"')						// ǥ ֱ..
		{
			*q = *p;
			q++;
		}
		p++;
	}
	*q = 0;

/////////////////// ܼ  ///////////////////////////
#ifdef _DEBUG
	AllocConsole();
	freopen( "conin$", "r", stdin );
	freopen( "conout$", "w", stdout );
	freopen( "conout$", "w", stderr );
#endif

	DialogBox(hInstance, (LPCTSTR)IDD_MAIN, NULL, (DLGPROC)MainDlgProc);

	delete g_szCmdLine;

/////////////////// ܼ  ///////////////////////////
#ifdef _DEBUG
	FreeConsole(); 
#endif

	return 0;
}


BOOL IsFile(LPCTSTR szPathName)
{
	DWORD dwRet;
	dwRet = GetFileAttributes(szPathName);
	if(dwRet==-1) return FALSE;
	if(dwRet & FILE_ATTRIBUTE_DIRECTORY) return FALSE;
	return TRUE;
}


void CenterWindow(HWND hWnd)
{
	RECT rcTemp1, rcTemp2 ;
	LONG iX, iY, iWidth, iHeight ;

	GetWindowRect(GetDesktopWindow(),&rcTemp1) ;
	GetWindowRect(hWnd,&rcTemp2) ;
	iWidth = rcTemp2.right - rcTemp2.left ;
	iHeight = rcTemp2.bottom - rcTemp2.top ;
	iX = LONG((rcTemp1.right - iWidth) / 2) ;
	iY = LONG((rcTemp1.bottom - iHeight) / 2) ;
	MoveWindow(hWnd,iX,iY,iWidth,iHeight,TRUE) ;
}

void PumpUntilEmpty(HWND hWnd)
{
	MSG msg;
	while(::PeekMessage(&msg, hWnd, 0, 0, PM_REMOVE))
	{
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
}

BOOL ExtractResource(LPCTSTR sResName, LPCTSTR szDst)
{
	HRSRC		hResInfo;
	HANDLE		hRes;
	int			nBufSize;
	FILE*		fp;
	
	TCHAR		szType[] = _T("BIN");
	TCHAR*		szRes;
	

	fp = _tfopen(szDst, _T("wb"));
	if(fp==NULL) return FALSE;

	
	hResInfo = FindResource(hInst, sResName, szType);
	if (hResInfo == NULL)  { fclose(fp); return FALSE; }
	
	// Load the resource
	hRes = LoadResource(hInst, hResInfo);
	
	// Lock the resource
	szRes = (TCHAR*)LockResource(hRes);

	if (szRes == NULL) { fclose(fp); FreeResource(hRes); return FALSE; }

	nBufSize = SizeofResource(hInst, hResInfo);
	fwrite(szRes, 1, nBufSize, fp);
	UnlockResource(hRes);  
	
	// Free the resource
	FreeResource(hRes);
	fclose(fp);

	return TRUE;
}

TCHAR g_sGetDirectoryDir[MAX_PATH];
static int CALLBACK BrowseCallbackProc(HWND hwnd,UINT msg,LPARAM lp, LPARAM pData)
{
	TCHAR buf[MAX_PATH];
	switch(msg) 
	{
	case BFFM_INITIALIZED: 
		_tcscpy(buf,g_sGetDirectoryDir);
		::SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)buf);
		break;
	case BFFM_SELCHANGED:
		if (::SHGetPathFromIDList((LPITEMIDLIST) lp ,buf)) 
			SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)buf);
		break;
	}
	return 0;
}

#ifndef BIF_NEWDIALOGSTYLE
  #define BIF_NEWDIALOGSTYLE     0x0040   // Use the new dialog layout with the ability to resize
  #define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
#endif
LPCTSTR GetDirectory(HWND hWndParent, LPCTSTR szRoot, LPCTSTR szTitle)
{
	static TCHAR str[MAX_PATH];
	BROWSEINFO bi;
    bi.hwndOwner=hWndParent;		//owner of created dialog box
    bi.pidlRoot=0;					//unused
    bi.pszDisplayName=0;			//buffer to receive name displayed by folder (not a valid path)
    bi.lpszTitle=szTitle;			//title is "Browse for Folder", this is an instruction
	bi.lpfn = BrowseCallbackProc;	//callback routine called when dialog has been initialized
    bi.lParam=0;					//passed to callback routine
    bi.ulFlags=
		BIF_RETURNONLYFSDIRS |		//only allow user to select a directory
		BIF_STATUSTEXT |			//create status text field we will be writing to in callback
		BIF_NEWDIALOGSTYLE |		// resizing  ο Ÿ..OleInitialize()  ȣ Ǿ־ ..
//		BIF_BROWSEFORCOMPUTER|		//only allow user to select a computer
//		BIF_BROWSEFORPRINTER |		//only allow user to select a printer
//		BIF_BROWSEINCLUDEFILES|		//displays files too which user can pick
//		BIF_DONTGOBELOWDOMAIN|		//when user is exploring the "Entire Network" they
									// are not allowed into any domain
		0; 
	_tcscpy(g_sGetDirectoryDir, szRoot);

	LPITEMIDLIST lpItemId=::SHBrowseForFolder(&bi); 
	if (lpItemId)
	{
		::SHGetPathFromIDList(lpItemId, str);
		::GlobalFree(lpItemId);
	}

	return str;
}

void SetFileName(HWND hDlg, LPCTSTR szPathName)
{
	SetDlgItemText(hDlg, IDC_EDIT_ZIPPATH, szPathName);
	//TCHAR* temp = _tcsrchr(szPathName, '\\');
	TCHAR* temp = _tcsrchr(szPathName, '.');
	
	if(temp)
	{
		*(temp) = '\\';
		*(temp+1) = 0;
		SetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPathName);
	}
}


#ifndef LVM_SETEXTENDEDLISTVIEWSTYLE
#define LVM_SETEXTENDEDLISTVIEWSTYLE (LVM_FIRST + 54)   // optional wParam == mask
#endif

void SetListControl(HWND hList)
{
	LVCOLUMN	lvcolumn;
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcolumn.fmt = LVCFMT_LEFT;
	lvcolumn.iSubItem = 0;

	RECT r;
	::GetWindowRect(hList, &r);
	lvcolumn.cx = 100;
	lvcolumn.pszText = (LPTSTR)_T("޽");

	::SendMessage(hList, LVM_INSERTCOLUMN, 0, (LPARAM)&lvcolumn);
//	::SendMessage(hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (LPARAM) LVS_EX_FULLROWSELECT);
	::SendMessage(hList, LVM_SETCOLUMNWIDTH, 0, (LPARAM)LVSCW_AUTOSIZE_USEHEADER);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          list control  ޽ Ѹ
/// @date    2004-03-01  6:12:51
////////////////////////////////////////////////////////////////////////////////////////////////////
#define LEN_MSG	2048
void Message(HWND hList, LPCTSTR str, ...)
{
	TCHAR	msg[LEN_MSG];
	BOOL	bPartialOK = FALSE;
	va_list args;
	va_start(args, str);
	_vstprintf(msg, str, args);
	va_end(args);

	int	nCount = ::SendMessage(hList, LVM_GETITEMCOUNT, 0, 0L);

	LVITEM item;
	item.mask = LVIF_TEXT;
	item.iItem = nCount;
	item.iSubItem = 0;
	item.pszText = (LPTSTR)msg;
	item.state = 0;
	item.stateMask = 0;
	item.iImage = 0;
	item.lParam = 0;

	::SendMessage(hList, LVM_INSERTITEM, 0, (LPARAM)&item);
	::SendMessage(hList, LVM_ENSUREVISIBLE, (LPARAM)nCount,MAKELPARAM(bPartialOK, 0));
	::SendMessage(hList, LVM_SETCOLUMNWIDTH, 0, (LPARAM)LVSCW_AUTOSIZE_USEHEADER);
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///          control enable/disable ϱ
/// @date    2004-03-01  6:34:40
////////////////////////////////////////////////////////////////////////////////////////////////////
static void EnableControl(HWND hDlg, BOOL bExtracting)
{
	BOOL bEnable;
	BOOL bDisable;

	if(bExtracting)
	{
		bEnable = FALSE;
		bDisable = TRUE;
	}
	else
	{
		bEnable = TRUE;
		bDisable = FALSE;
	}
	
	// ҿ enable
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_ZIPPATH),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_OUTPATH),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FINDZIP),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FINDPATH), bEnable);
	EnableWindow(GetDlgItem(hDlg, IDCANCEL),			bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_EXTRACT),	bEnable);

	// Ǯ enable
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_STOP),		bDisable);
}


LRESULT CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND	hList = GetDlgItem(hDlg, IDC_LIST_MESSAGE);
	switch (message)
	{
	case WM_INITDIALOG:
		::SendMessage(hDlg, WM_SETICON, TRUE, (LPARAM)g_hIconBig);
		::SendMessage(hDlg, WM_SETICON, FALSE, (LPARAM)g_hIconSmall);
		CenterWindow(hDlg);
		DragAcceptFiles(hDlg, TRUE);

		if(g_szCmdLine && _tcslen(g_szCmdLine))
			SetFileName(hDlg, g_szCmdLine);

		SetListControl(hList);
		EnableControl(hDlg, FALSE);

		// codepage
		{
			int  i;
			HWND hCombo = ::GetDlgItem(hDlg, IDC_COMBO_CP);
			for(i=0;i<sizeof(g_supportedCodePages)/sizeof(g_supportedCodePages[0]);i++)
			{
				ComboBox_AddString(hCombo, g_supportedCodePages[i].szDesc);
				ComboBox_SetItemData(hCombo, i, g_supportedCodePages[i].nCodepage);		// codepage  itemdata  .
			}
			ComboBox_SetCurSel(hCombo, 0);		// ⺻ - Ϻ.
		}

		//ComboBox_SetCurSel
		//IDC_COMBO_CP

		return TRUE;
		
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDC_BUTTON_EXTRACT :
				{
					TCHAR szSrc[MAX_PATH];
					TCHAR szDst[MAX_PATH];
					CHAR szFileName[MAX_PATH];
					WCHAR szFileNameW[MAX_PATH];
					unzFile		uf;
					int			ret;
					BOOL		bRet=FALSE;
					HWND hCombo = ::GetDlgItem(hDlg, IDC_COMBO_CP);
					unz_file_info	file_info;

					g_bHalt = FALSE;

					GetDlgItemText(hDlg, IDC_EDIT_ZIPPATH, szSrc, MAX_PATH);
					GetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szDst, MAX_PATH);


					// codepgage
					g_nCodePage = ComboBox_GetItemData(hCombo, ComboBox_GetCurSel(hCombo));

					if(lstrlen(szSrc)==0)
					{
						MessageBox(hDlg, _T(".ZIP    ֻ. 巡&ӵ ."), APP, MB_OK);
						return 0;
					}

					if(::IsFile(szSrc)==FALSE)
					{
						MessageBox(hDlg, _T(".ZIP  ΰ ٸ ʾ."), APP, MB_OK);
						return 0;
					}

					#ifdef _UNICODE
					uf = unzOpenW(szSrc);
					#else
					uf = unzOpen(szSrc);
					#endif
					if (uf==NULL) 
					{
						MessageBox(hDlg, _T(".ZIP  ƴϰų  ջƾ."), APP, MB_OK);
						return 0;
					}

					EnableControl(hDlg, TRUE);

					ret = unzGoToFirstFile(uf);
					if(ret!=UNZ_OK) goto END;

					for(;;)
					{
						ret = unzGetCurrentFileInfo(uf, &file_info, szFileName, MAX_PATH, NULL,0, NULL, 0);

						//MultiByteToWideChar(CP_ACP, 0, szFileName, -1, szFileNameW, MAX_PATH);
						MultiByteToWideChar(g_nCodePage, 0, szFileName, -1, szFileNameW, MAX_PATH);	   // 932==japan

						if(ret!=UNZ_OK) goto END;

						ret = unzOpenCurrentFile(uf);
						if (ret!=UNZ_OK)
						{
							Message(hList, _T("  :%s"), szFileName);
							break;
						}

						TCHAR szResult[MAX_PATH];
						
						lstrcpy(szResult, szDst);
						if( szResult[lstrlen(szResult)-1] != _T('\\'))
							lstrcat(szResult, _T("\\"));
						lstrcat(szResult, szFileNameW);

						#define BUF_LEN 4096
						BYTE buf[BUF_LEN];
						int len;

						//  .
						DigPath(szResult);

						if(::IsFolder(szResult)==FALSE)
						{
							// Ϸ .
							FILE* fp;
							fp = _tfopen(szResult, _T("wb"));
							if(fp==NULL)
							{
								Message(hList, _T("  :%s"), szResult);
								break;
							}
							Message(hList,_T("%s,%dbytes"), szFileNameW,file_info.uncompressed_size);

							for(;;)
							{
								len = unzReadCurrentFile(uf,buf, BUF_LEN);
								if (len<0)	
								{
									goto END;
								}
								if(len==0) break;
								fwrite(buf, 1, len, fp);
								PumpUntilEmpty(hDlg);
								if(g_bHalt) 
								{
									Message(hList, _T(""));
									goto END;
								}
							}

							fclose(fp);
						}

						unzCloseCurrentFile(uf);


						ret = unzGoToNextFile(uf);
						if(ret==UNZ_END_OF_LIST_OF_FILE)
						{
							break;
						}
					}

					Message(hList, _T(""));



					END:
					EnableControl(hDlg, FALSE);
					if(uf) unzCloseCurrentFile(uf);
					if(uf) unzClose(uf);
					return 0;
				}
				break;


			case IDC_BUTTON_FINDZIP :
				{
					TCHAR* szFile;
					OPENFILENAME ofn;       
					szFile = (TCHAR*)calloc(sizeof(TCHAR), MAX_PATH*2);

					// Initialize OPENFILENAME
					ZeroMemory(&ofn, sizeof(OPENFILENAME));
					ofn.lStructSize = sizeof(OPENFILENAME);
					ofn.hwndOwner = hDlg;
					ofn.lpstrFile = szFile;
					ofn.nMaxFile = MAX_PATH;
					ofn.lpstrFilter = _T("ZIP\0*.ZIP\0\0*.*\0\0");
					ofn.nFilterIndex = 1;
					ofn.lpstrFileTitle = NULL;
					ofn.nMaxFileTitle = 0;
					ofn.lpstrTitle = _T(" ");
					ofn.lpstrInitialDir = NULL;
					ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

					if (!GetOpenFileName (&ofn)) { free(szFile); return 0; }


					SetFileName(hDlg, szFile);

					free(szFile);
				}
				return 0;

			case IDC_OPEN_FOLDER :
				{
					TCHAR szPath[MAX_PATH];
					GetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPath, MAX_PATH);
					ShellExecute(NULL, _T("open"), szPath, NULL, NULL, SW_SHOW);
				}
				return 0;

			case IDC_BUTTON_STOP :
				g_bHalt = TRUE;
				return 0;

			case IDC_BUTTON_FINDPATH :
				{
					TCHAR szPath[MAX_PATH];
					GetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPath, MAX_PATH);

					LPCTSTR szPath2 = GetDirectory(hDlg, szPath, _T("Ǯ  "));
					if(_tcslen(szPath2)==0) return 0;
					SetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPath2);
					return 0;
				}

			case IDC_BUTTON_ABOUT :
				MessageBox(hDlg, TXT_ABOUT, APP, MB_OK|MB_ICONEXCLAMATION);
				return 0;

			case IDOK :
			case IDCANCEL :
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;

	case WM_DROPFILES :
		{
			HDROP			hDropInfo = (HDROP) wParam; 
			TCHAR			szPathName[_MAX_PATH];
			int				nCount;

			nCount = ::DragQueryFile(hDropInfo, 0xffffffff, NULL, 0);

			::DragQueryFile(hDropInfo, 0, szPathName, _MAX_PATH);

			SetFileName(hDlg, szPathName);
			::DragFinish(hDropInfo);

		}
		break;

	}
    return FALSE;
}


